stages:
  - build

.build: &build-job
  image: registry.gitlab.com/elodie.billiot/packer-aws-weshare/workstation:xxx
  stage: build
  environment:
    name: $STAGE
  script:
    - ansible-galaxy collection install -r ansible/requirements.yml
    - ansible-galaxy install -r ansible/requirements.yml -p ./ansible/roles --force
    - packer validate -var "ami_name=$STAGE-$AMI-$CI_COMMIT_SHORT_SHA-ami" -var "aws_target_account=$STAGE" -var "user_id=$ACCOUNT" packer/$AMI.pkr.hcl
    - packer build ${opts} -var "ami_name=$STAGE-$AMI-$CI_COMMIT_SHORT_SHA-ami" -var "aws_target_account=$STAGE" -var "user_id=$ACCOUNT" packer/$AMI.pkr.hcl
  parallel:
    matrix:
      - AMI: ["master", "front", "back"]

build:sandbox:
  <<: *build-job
  variables:
    STAGE: sandbox
    ACCOUNT: $SANDBOX_ACCOUNT
    AWS_REGION: eu-west-1
  rules:
    - if: $CI_COMMIT_BRANCH == "sandbox"
      changes:
        - packer/$AMI.pkr.hcl
        - ansible/$AMI.yml
        - ansible/requirement.yml
      when: manual

build:dev:
  <<: *build-job
  variables:
    STAGE: dev
    ACCOUNT: $DEV_ACCOUNT
    AWS_REGION: eu-west-1
  rules:
    - if: $CI_COMMIT_BRANCH == "develop"
      changes:
        - packer/$AMI.pkr.hcl
        - ansible/$AMI.yml
        - ansible/requirement.yml
      when: manual

build:staging:
  <<: *build-job
  variables:
    STAGE: staging
    ACCOUNT: $STAGING_ACCOUNT
    AWS_REGION: eu-west-1
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
      changes:
        - packer/$AMI.pkr.hcl
        - ansible/$AMI.yml
        - ansible/requirement.yml
      when: manual

build:prod:
  <<: *build-job
  variables:
    STAGE: prod
    ACCOUNT: $PROD_ACCOUNT
    AWS_REGION: eu-west-1
  rules:
    - if: $CI_COMMIT_TAG != null
      changes:
        - packer/$AMI.pkr.hcl
        - ansible/$AMI.yml
        - ansible/requirement.yml
      when: manual